/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.sablecc.pascal.lexer;

import java.io.*;
import java.util.*;
import org.sablecc.pascal.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;
    }
 
    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TEnd(text, line, pos); }
    Token new1(String text, int line, int pos) { return new TDiv(text, line, pos); }
    Token new2(String text, int line, int pos) { return new TVar(text, line, pos); }
    Token new3(String text, int line, int pos) { return new TBegin(text, line, pos); }
    Token new4(String text, int line, int pos) { return new TProgram(text, line, pos); }
    Token new5(String text, int line, int pos) { return new TWriteln(text, line, pos); }
    Token new6(String text, int line, int pos) { return new TInteger(text, line, pos); }
    Token new7(int line, int pos) { return new TPlus(line, pos); }
    Token new8(int line, int pos) { return new TMinus(line, pos); }
    Token new9(int line, int pos) { return new TMult(line, pos); }
    Token new10(int line, int pos) { return new TAssignop(line, pos); }
    Token new11(int line, int pos) { return new TComma(line, pos); }
    Token new12(int line, int pos) { return new TColon(line, pos); }
    Token new13(int line, int pos) { return new TSemicolon(line, pos); }
    Token new14(int line, int pos) { return new TDot(line, pos); }
    Token new15(int line, int pos) { return new TLParen(line, pos); }
    Token new16(int line, int pos) { return new TRParen(line, pos); }
    Token new17(String text, int line, int pos) { return new TIdentifier(text, line, pos); }
    Token new18(String text, int line, int pos) { return new TNumber(text, line, pos); }
    Token new19(String text, int line, int pos) { return new TComment(text, line, pos); }
    Token new20(String text, int line, int pos) { return new TBlanks(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {40, 40, 5}, {41, 41, 6}, {42, 42, 7}, {43, 43, 8}, {44, 44, 9}, {45, 45, 10}, {46, 46, 11}, {48, 57, 12}, {58, 58, 13}, {59, 59, 14}, {65, 65, 15}, {66, 66, 16}, {67, 67, 15}, {68, 68, 17}, {69, 69, 18}, {70, 72, 15}, {73, 73, 19}, {74, 79, 15}, {80, 80, 20}, {81, 85, 15}, {86, 86, 21}, {87, 87, 22}, {88, 90, 15}, {97, 97, 15}, {98, 98, 23}, {99, 99, 15}, {100, 100, 24}, {101, 101, 25}, {102, 104, 15}, {105, 105, 26}, {106, 111, 15}, {112, 112, 27}, {113, 117, 15}, {118, 118, 28}, {119, 119, 29}, {120, 122, 15}, {123, 123, 30}, },
            {},
            {},
            {{10, 10, 31}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{48, 57, 12}, },
            {{61, 61, 32}, },
            {},
            {{48, 57, 33}, {65, 90, 34}, {97, 122, 34}, },
            {{48, 57, 33}, {65, 68, 34}, {69, 69, 35}, {70, 90, 34}, {97, 100, 34}, {101, 101, 36}, {102, 122, 34}, },
            {{48, 57, 33}, {65, 72, 34}, {73, 73, 37}, {74, 90, 34}, {97, 104, 34}, {105, 105, 38}, {106, 122, 34}, },
            {{48, 57, 33}, {65, 77, 34}, {78, 78, 39}, {79, 90, 34}, {97, 109, 34}, {110, 110, 40}, {111, 122, 34}, },
            {{48, 77, -20}, {78, 78, 41}, {79, 109, -20}, {110, 110, 42}, {111, 122, 34}, },
            {{48, 57, 33}, {65, 81, 34}, {82, 82, 43}, {83, 90, 34}, {97, 113, 34}, {114, 114, 44}, {115, 122, 34}, },
            {{48, 57, 33}, {65, 65, 45}, {66, 90, 34}, {97, 97, 46}, {98, 122, 34}, },
            {{48, 81, -22}, {82, 82, 47}, {83, 113, -22}, {114, 114, 48}, {115, 122, 34}, },
            {{48, 122, -18}, },
            {{48, 122, -19}, },
            {{48, 122, -20}, },
            {{48, 122, -21}, },
            {{48, 122, -22}, },
            {{48, 122, -23}, },
            {{48, 122, -24}, },
            {{32, 122, 49}, {124, 124, 49}, {125, 125, 50}, {126, 127, 49}, },
            {},
            {},
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 90, -17}, {97, 102, 34}, {103, 103, 51}, {104, 122, 34}, },
            {{48, 122, -37}, },
            {{48, 57, 33}, {65, 85, 34}, {86, 86, 52}, {87, 90, 34}, {97, 117, 34}, {118, 118, 53}, {119, 122, 34}, },
            {{48, 122, -39}, },
            {{48, 57, 33}, {65, 67, 34}, {68, 68, 54}, {69, 90, 34}, {97, 99, 34}, {100, 100, 55}, {101, 122, 34}, },
            {{48, 122, -41}, },
            {{48, 57, 33}, {65, 83, 34}, {84, 84, 56}, {85, 90, 34}, {97, 115, 34}, {116, 116, 57}, {117, 122, 34}, },
            {{48, 122, -43}, },
            {{48, 57, 33}, {65, 78, 34}, {79, 79, 58}, {80, 90, 34}, {97, 110, 34}, {111, 111, 59}, {112, 122, 34}, },
            {{48, 122, -45}, },
            {{48, 81, -22}, {82, 82, 60}, {83, 113, -22}, {114, 114, 61}, {115, 122, 34}, },
            {{48, 122, -47}, },
            {{48, 72, -19}, {73, 73, 62}, {74, 104, -19}, {105, 105, 63}, {106, 122, 34}, },
            {{48, 122, -49}, },
            {{32, 127, -32}, },
            {},
            {{48, 72, -19}, {73, 73, 64}, {74, 104, -19}, {105, 105, 65}, {106, 122, 34}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 68, -18}, {69, 69, 66}, {70, 100, -18}, {101, 101, 67}, {102, 122, 34}, },
            {{48, 122, -58}, },
            {{48, 102, -37}, {103, 103, 68}, {104, 122, 34}, },
            {{48, 122, -60}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 83, -43}, {84, 84, 69}, {85, 115, -43}, {116, 116, 70}, {117, 122, 34}, },
            {{48, 122, -64}, },
            {{48, 77, -20}, {78, 78, 71}, {79, 109, -20}, {110, 110, 72}, {111, 122, 34}, },
            {{48, 122, -66}, },
            {{48, 102, -37}, {103, 103, 73}, {104, 122, 34}, },
            {{48, 122, -68}, },
            {{48, 81, -22}, {82, 82, 74}, {83, 113, -22}, {114, 114, 75}, {115, 122, 34}, },
            {{48, 68, -18}, {69, 69, 76}, {70, 100, -18}, {101, 101, 77}, {102, 122, 34}, },
            {{48, 122, -71}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 68, -18}, {69, 69, 78}, {70, 100, -18}, {101, 101, 79}, {102, 122, 34}, },
            {{48, 57, 33}, {65, 65, 80}, {66, 90, 34}, {97, 97, 81}, {98, 122, 34}, },
            {{48, 122, -76}, },
            {{48, 57, 33}, {65, 75, 34}, {76, 76, 82}, {77, 90, 34}, {97, 107, 34}, {108, 108, 83}, {109, 122, 34}, },
            {{48, 122, -78}, },
            {{48, 81, -22}, {82, 82, 84}, {83, 113, -22}, {114, 114, 85}, {115, 122, 34}, },
            {{48, 122, -80}, },
            {{48, 57, 33}, {65, 76, 34}, {77, 77, 86}, {78, 90, 34}, {97, 108, 34}, {109, 109, 87}, {110, 122, 34}, },
            {{48, 122, -82}, },
            {{48, 77, -20}, {78, 78, 88}, {79, 109, -20}, {110, 110, 89}, {111, 122, 34}, },
            {{48, 122, -84}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {-1, 20, 20, 20, 20, 15, 16, 9, 7, 11, 8, 14, 18, 12, 13, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, -1, 20, 10, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, -1, 19, 17, 1, 1, 0, 0, 17, 17, 17, 17, 2, 2, 17, 17, 17, 17, 17, 17, 17, 17, 17, 3, 3, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 6, 6, 4, 4, 5, 5, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
